OpenShot Audio Library | OpenShotAudio: juce::MemoryOutputStream Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.2

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::MemoryOutputStream Class Reference

`#include <juce_MemoryOutputStream.h>`

Inheritance diagram for juce::MemoryOutputStream:

## Public Member Functions
| MemoryOutputStream (size_t initialSize=256)
| MemoryOutputStream (MemoryBlock &memoryBlockToWriteTo, bool appendToExistingBlockContent)
| MemoryOutputStream (void *destBuffer, size_t destBufferSize)
| ~MemoryOutputStream () override
const void * | getData () const noexcept
size_t | getDataSize () const noexcept
void | reset () noexcept
void | preallocate (size_t bytesToPreallocate)
bool | appendUTF8Char (juce_wchar character)
String | toUTF8 () const
String | toString () const
MemoryBlock | getMemoryBlock () const
void | flush () override
bool | write (const void *, size_t) override
int64 | getPosition () override
bool | setPosition (int64) override
int64 | writeFromInputStream (InputStream &, int64 maxNumBytesToWrite) override
bool | writeRepeatedByte (uint8 byte, size_t numTimesToRepeat) override
Public Member Functions inherited from juce::OutputStream
virtual | ~OutputStream ()
virtual void | flush ()=0
virtual bool | setPosition (int64 newPosition)=0
virtual int64 | getPosition ()=0
virtual bool | write (const void *dataToWrite, size_t numberOfBytes)=0
virtual bool | writeByte (char byte)
virtual bool | writeBool (bool boolValue)
virtual bool | writeShort (short value)
virtual bool | writeShortBigEndian (short value)
virtual bool | writeInt (int value)
virtual bool | writeIntBigEndian (int value)
virtual bool | writeInt64 (int64 value)
virtual bool | writeInt64BigEndian (int64 value)
virtual bool | writeFloat (float value)
virtual bool | writeFloatBigEndian (float value)
virtual bool | writeDouble (double value)
virtual bool | writeDoubleBigEndian (double value)
virtual bool | writeRepeatedByte (uint8 byte, size_t numTimesToRepeat)
virtual bool | writeCompressedInt (int value)
virtual bool | writeString (const String &text)
virtual bool | writeText (const String &text, bool asUTF16, bool writeUTF16ByteOrderMark, const char *lineEndings)
virtual int64 | writeFromInputStream (InputStream &source, int64 maxNumBytesToWrite)
void | setNewLineString (const String &newLineString)
const String & | getNewLineString () const noexcept

## Detailed Description

Writes data to an internal memory buffer, which grows as required.

The data that was written into the stream can then be accessed later as a contiguous block of memory.

Definition at line 35 of file juce_MemoryOutputStream.h.

## Constructor & Destructor Documentation

## ◆ MemoryOutputStream() [1/3]

juce::MemoryOutputStream::MemoryOutputStream | ( | size_t | initialSize = `256` | ) |

Creates an empty memory stream, ready to be written into.

Parameters

  initialSize | the initial amount of capacity to allocate for writing into

Definition at line 26 of file juce_MemoryOutputStream.cpp.

## ◆ MemoryOutputStream() [2/3]

juce::MemoryOutputStream::MemoryOutputStream | ( | MemoryBlock & | memoryBlockToWriteTo,
|  | bool | appendToExistingBlockContent
| ) |  |

Creates a memory stream for writing into into a pre-existing MemoryBlock object.

Note that the destination block will always be larger than the amount of data that has been written to the stream, because the MemoryOutputStream keeps some spare capacity at its end. To trim the block's size down to fit the actual data, call flush(), or delete the MemoryOutputStream.

Parameters

  memoryBlockToWriteTo | the block into which new data will be written.
  appendToExistingBlockContent | if this is true, the contents of the block will be kept, and new data will be appended to it. If false, the block will be cleared before use

Definition at line 32 of file juce_MemoryOutputStream.cpp.

## ◆ MemoryOutputStream() [3/3]

juce::MemoryOutputStream::MemoryOutputStream | ( | void * | destBuffer,
|  | size_t | destBufferSize
| ) |  |

Creates a MemoryOutputStream that will write into a user-supplied, fixed-size block of memory. When using this mode, the stream will write directly into this memory area until it's full, at which point write operations will fail.

Definition at line 40 of file juce_MemoryOutputStream.cpp.

## ◆ ~MemoryOutputStream()

juce::MemoryOutputStream::~MemoryOutputStream | ( |  | ) |
| override

Destructor. This will free any data that was written to it.

Definition at line 46 of file juce_MemoryOutputStream.cpp.

## Member Function Documentation

## ◆ appendUTF8Char()

bool juce::MemoryOutputStream::appendUTF8Char | ( | juce_wchar | character | ) |

Appends the utf-8 bytes for a unicode character

Definition at line 132 of file juce_MemoryOutputStream.cpp.

## ◆ flush()

void juce::MemoryOutputStream::flush | ( |  | ) |
| overridevirtual

If the stream is writing to a user-supplied MemoryBlock, this will trim any excess capacity off the block, so that its length matches the amount of actual data that has been written so far.

Implements juce::OutputStream.

Definition at line 51 of file juce_MemoryOutputStream.cpp.

## ◆ getData()

const void * juce::MemoryOutputStream::getData | ( |  | ) | const
| noexcept

Returns a pointer to the data that has been written to the stream.

See also
  getDataSize

Definition at line 148 of file juce_MemoryOutputStream.cpp.

Referenced by juce::XmlDocument::getDocumentElement(), getMemoryBlock(), juce::ValueTreeSynchroniser::sendFullSyncCallback(), toString(), and toUTF8().

## ◆ getDataSize()

size_t juce::MemoryOutputStream::getDataSize | ( |  | ) | const
| inlinenoexcept

Returns the number of bytes of data that have been written to the stream.

See also
  getData

Definition at line 80 of file juce_MemoryOutputStream.h.

Referenced by juce::XmlDocument::getDocumentElement(), getMemoryBlock(), juce::ValueTreeSynchroniser::sendFullSyncCallback(), toString(), and toUTF8().

## ◆ getMemoryBlock()

MemoryBlock juce::MemoryOutputStream::getMemoryBlock | ( |  | ) | const

Returns a copy of the stream's data as a memory block.

Definition at line 143 of file juce_MemoryOutputStream.cpp.

## ◆ getPosition()

int64 juce::MemoryOutputStream::getPosition | ( |  | ) |
| inlineoverridevirtual

Returns the stream's current position.

See also
  setPosition

Implements juce::OutputStream.

Definition at line 112 of file juce_MemoryOutputStream.h.

## ◆ preallocate()

void juce::MemoryOutputStream::preallocate | ( | size_t | bytesToPreallocate | ) |

Increases the internal storage capacity to be able to contain at least the specified amount of data without needing to be resized.

Definition at line 62 of file juce_MemoryOutputStream.cpp.

Referenced by writeFromInputStream().

## ◆ reset()

void juce::MemoryOutputStream::reset | ( |  | ) |
| noexcept

Resets the stream, clearing any data that has been written to it so far.

Definition at line 68 of file juce_MemoryOutputStream.cpp.

## ◆ setPosition()

bool juce::MemoryOutputStream::setPosition | ( | int64 | newPosition | ) |
| overridevirtual

Tries to move the stream's output position.

Not all streams will be able to seek to a new position - this will return false if it fails to work.

See also
  getPosition

Implements juce::OutputStream.

Definition at line 159 of file juce_MemoryOutputStream.cpp.

## ◆ toString()

String juce::MemoryOutputStream::toString | ( |  | ) | const

Attempts to detect the encoding of the data and convert it to a string.

See also
  String::createStringFromData

Definition at line 195 of file juce_MemoryOutputStream.cpp.

Referenced by juce::JSON::escapeString(), juce::XmlDocument::getDocumentElement(), juce::ChildProcess::readAllProcessOutput(), juce::InputStream::readEntireStreamAsString(), juce::Base64::toBase64(), and juce::dsp::Matrix< ElementType >::toString().

## ◆ toUTF8()

String juce::MemoryOutputStream::toUTF8 | ( |  | ) | const

Returns a String created from the (UTF8) data that has been written to the stream.

Definition at line 189 of file juce_MemoryOutputStream.cpp.

Referenced by juce::XmlElement::getAllSubText(), juce::var::readFromStream(), juce::InputStream::readNextLine(), juce::InputStream::readString(), juce::XmlElement::toString(), and juce::JSON::toString().

## ◆ write()

bool juce::MemoryOutputStream::write | ( | const void * | dataToWrite,
|  | size_t | numberOfBytes
| ) |  |
| overridevirtual

Writes a block of data to the stream.

When creating a subclass of OutputStream, this is the only write method that needs to be overloaded - the base class has methods for writing other types of data which use this to do the work.

Parameters

  dataToWrite | the target buffer to receive the data. This must not be null.
  numberOfBytes | the number of bytes to write.

Returns
  false if the write operation fails for some reason

Implements juce::OutputStream.

Definition at line 102 of file juce_MemoryOutputStream.cpp.

Referenced by juce::ChildProcess::readAllProcessOutput().

## ◆ writeFromInputStream()

int64 juce::MemoryOutputStream::writeFromInputStream | ( | InputStream & | source,
|  | int64 | maxNumBytesToWrite
| ) |  |
| overridevirtual

Reads data from an input stream and writes it to this stream.

Parameters

  source | the stream to read from
  maxNumBytesToWrite | the number of bytes to read from the stream (if this is less than zero, it will keep reading until the input is exhausted)

Returns
  the number of bytes written

Reimplemented from juce::OutputStream.

Definition at line 172 of file juce_MemoryOutputStream.cpp.

Referenced by juce::XmlDocument::getDocumentElement(), juce::var::readFromStream(), and juce::InputStream::readIntoMemoryBlock().

## ◆ writeRepeatedByte()

bool juce::MemoryOutputStream::writeRepeatedByte | ( | uint8 | byte,
|  | size_t | numTimesToRepeat
| ) |  |
| overridevirtual

Writes a byte to the output stream a given number of times.

Returns
  false if the write operation fails for some reason

Reimplemented from juce::OutputStream.

Definition at line 118 of file juce_MemoryOutputStream.cpp.

The documentation for this class was generated from the following files:

- juce_MemoryOutputStream.h
- juce_MemoryOutputStream.cpp